﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace MazeGenerator.MazeGenerator
{
    public abstract class AbstractMazeGenerator : Maze
    {
        protected static Random rand = new Random();

        public AbstractMazeGenerator(int width, int height)
            : base(width, height)
        {
            /* nothing to do here */
        }

        public AbstractMazeGenerator(int width, int height, int startCellX, int startCellY)
            : base(width, height, startCellX, startCellY)
        {
        }

        /// <summary>
        /// Get the four directions of a maze in random order
        /// </summary>
        /// <returns></returns>
        protected MazeDir[] GetRandomMazeDirOrder()
        {
            // build array with normal order
            MazeDir[] dirs = { MazeDir.NORTH, MazeDir.EAST, MazeDir.SOUTH, MazeDir.WEST };
            // shuffle array
            for (int i = 0; i < 4; i++)
            {
                MazeDir temp = dirs[i];
                int swapIndex = rand.Next(4);
                dirs[i] = dirs[swapIndex];
                dirs[swapIndex] = temp;
            }
            return dirs;
        }
    }
}
