﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Text;
using System.Collections.Generic;

namespace MazeGenerator.MazeGenerator
{
    /// <summary>
    /// Helper class used by Eller's algorithm. Represents a set which contains a number of cells.
    /// </summary>
    public class CellsOfEllerSet
    {
        List<int> cellNrList;
        int ID;

        public CellsOfEllerSet(int id)
        {
            cellNrList = new List<int>();
            this.ID = id;
        }

        public void AddCell(int cellNr)
        {
            cellNrList.Add(cellNr);
        }

        public bool ContainsCell(int cellNr)
        {
            return cellNrList.Contains(cellNr);
        }

        public int GetID()
        {
            return ID;
        }

        public int Count()
        {
            return cellNrList.Count;
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("Cells in set " + ID + " : ");
            foreach (int i in cellNrList)
            {
                sb.Append(i + " ");
            }
            return sb.ToString();
        }

        public IEnumerator<int> GetEnumerator()
        {
            foreach (int cellNr in cellNrList)
            {
                yield return cellNr;
            }
        }
    }
}
